#ifndef INSTRS_H__
#define INSTRS_H__ 1

/* DO NOT EDIT!
 *
 * This file is created automatically by make_func from
 * the specifications in func_spec.
 *
 * It holds the bytecode values for all machine instructions, plus
 * declarations of the tables holding information about the instructions.
 */

#include "exec.h"  /* struct instr_s == instr_t */

#define CODE_OFFSET  (0)
#define CODE_COUNT   (189)
  /* First offset and number of internal opcodes.
   */

#define EFUN_OFFSET  (189)
#define EFUN_COUNT   (24)
  /* First offset and number of efun opcodes.
   */

#define EFUN0_OFFSET  (213)
#define EFUN0_COUNT   (22)
  /* First offset and number of efun0 opcodes.
   */

#define EFUN1_OFFSET  (235)
#define EFUN1_COUNT   (119)
  /* First offset and number of efun1 opcodes.
   */

#define EFUN2_OFFSET  (354)
#define EFUN2_COUNT   (54)
  /* First offset and number of efun2 opcodes.
   */

#define EFUN3_OFFSET  (408)
#define EFUN3_COUNT   (13)
  /* First offset and number of efun3 opcodes.
   */

#define EFUN4_OFFSET  (421)
#define EFUN4_COUNT   (1)
  /* First offset and number of efun4 opcodes.
   */

#define EFUNV_OFFSET  (422)
#define EFUNV_COUNT   (67)
  /* First offset and number of efunv opcodes.
   */

#define LAST_INSTRUCTION_CODE (488)
  /* The highest token value in use.
   */

#define TEFUN_OFFSET EFUN0_OFFSET
  /* Offset of the first tabled efun.
   */

extern instr_t instrs[];
extern short efun_aliases[];
extern fulltype_t efun_arg_types[];
extern long efun_lpc_types[];
extern svalue_t *(*efun_table[])(svalue_t *);
extern svalue_t *(*vefun_table[])(svalue_t *, int);
  /* All tables are defined in efun_defs.c and compiled into lex.c
   * TODO: We might as well create efun_defs.h and compile it separately.
   */

/* --- codes --- */

#define F_ILLEGAL                      (0)
#define F_UNDEF                        (1)
#define F_EFUN0                        (2)
#define F_EFUN1                        (3)
#define F_EFUN2                        (4)
#define F_EFUN3                        (5)
#define F_EFUN4                        (6)
#define F_EFUNV                        (7)
#define F_IDENTIFIER                   (8)
#define F_STRING                       (9)
#define F_CSTRING0                     (10)
#define F_CSTRING1                     (11)
#define F_CSTRING2                     (12)
#define F_CSTRING3                     (13)
#define F_NUMBER                       (14)
#define F_CONST0                       (15)
#define F_CONST1                       (16)
#define F_NCONST1                      (17)
#define F_CLIT                         (18)
#define F_NCLIT                        (19)
#define F_FCONST0                      (20)
#define F_FLOAT                        (21)
#define F_CLOSURE                      (22)
#define F_SYMBOL                       (23)
#define F_RETURN                       (24)
#define F_RETURN0                      (25)
#define F_DEFAULT_RETURN               (26)
#define F_BREAK                        (27)
#define F_SWITCH                       (28)
#define F_SSCANF                       (29)
#define F_PARSE_COMMAND                (30)
#define F_LOCAL                        (31)
#define F_CATCH                        (32)
#define F_INC                          (33)
#define F_DEC                          (34)
#define F_POST_INC                     (35)
#define F_POST_DEC                     (36)
#define F_PRE_INC                      (37)
#define F_PRE_DEC                      (38)
#define F_LAND                         (39)
#define F_LOR                          (40)
#define F_ASSIGN                       (41)
#define F_VOID_ASSIGN                  (42)
#define F_ADD                          (43)
#define F_SUBTRACT                     (44)
#define F_MULTIPLY                     (45)
#define F_DIVIDE                       (46)
#define F_MOD                          (47)
#define F_GT                           (48)
#define F_GE                           (49)
#define F_LT                           (50)
#define F_LE                           (51)
#define F_EQ                           (52)
#define F_NE                           (53)
#define F_COMPL                        (54)
#define F_AND                          (55)
#define F_OR                           (56)
#define F_XOR                          (57)
#define F_LSH                          (58)
#define F_RSH                          (59)
#define F_RSHL                         (60)
#define F_NOT                          (61)
#define F_INDEX                        (62)
#define F_RINDEX                       (63)
#define F_AINDEX                       (64)
#define F_MAP_INDEX                    (65)
#define F_S_INDEX                      (66)
#define F_RANGE                        (67)
#define F_NR_RANGE                     (68)
#define F_RN_RANGE                     (69)
#define F_RR_RANGE                     (70)
#define F_NA_RANGE                     (71)
#define F_RA_RANGE                     (72)
#define F_AN_RANGE                     (73)
#define F_AR_RANGE                     (74)
#define F_AA_RANGE                     (75)
#define F_NX_RANGE                     (76)
#define F_RX_RANGE                     (77)
#define F_AX_RANGE                     (78)
#define F_VOID_ADD_EQ                  (79)
#define F_ADD_EQ                       (80)
#define F_SUB_EQ                       (81)
#define F_DIV_EQ                       (82)
#define F_MULT_EQ                      (83)
#define F_MOD_EQ                       (84)
#define F_AND_EQ                       (85)
#define F_OR_EQ                        (86)
#define F_XOR_EQ                       (87)
#define F_LSH_EQ                       (88)
#define F_RSH_EQ                       (89)
#define F_RSHL_EQ                      (90)
#define F_LAND_EQ                      (91)
#define F_LOR_EQ                       (92)
#define F_POP_VALUE                    (93)
#define F_POP_SECOND                   (94)
#define F_DUP                          (95)
#define F_LDUP                         (96)
#define F_SWAP_VALUES                  (97)
#define F_CLEAR_LOCALS                 (98)
#define F_SAVE_ARG_FRAME               (99)
#define F_RESTORE_ARG_FRAME            (100)
#define F_USE_ARG_FRAME                (101)
#define F_FLATTEN_XARG                 (102)
#define F_FBRANCH                      (103)
#define F_LBRANCH                      (104)
#define F_LBRANCH_WHEN_ZERO            (105)
#define F_LBRANCH_WHEN_NON_ZERO        (106)
#define F_BRANCH                       (107)
#define F_BRANCH_WHEN_ZERO             (108)
#define F_BRANCH_WHEN_NON_ZERO         (109)
#define F_BBRANCH_WHEN_ZERO            (110)
#define F_BBRANCH_WHEN_NON_ZERO        (111)
#define F_CALL_FUNCTION                (112)
#define F_CALL_INHERITED               (113)
#define F_CALL_INHERITED_NOARGS        (114)
#define F_CALL_CLOSURE                 (115)
#define F_CONTEXT_CLOSURE              (116)
#define F_CONTEXT_IDENTIFIER           (117)
#define F_PUSH_CONTEXT_LVALUE          (118)
#define F_CONTEXT_IDENTIFIER16         (119)
#define F_PUSH_CONTEXT16_LVALUE        (120)
#define F_PUSH_IDENTIFIER_LVALUE       (121)
#define F_VIRTUAL_VARIABLE             (122)
#define F_PUSH_VIRTUAL_VARIABLE_LVALUE (123)
#define F_IDENTIFIER16                 (124)
#define F_PUSH_IDENTIFIER16_LVALUE     (125)
#define F_PUSH_LOCAL_VARIABLE_LVALUE   (126)
#define F_PUSH_INDEXED_LVALUE          (127)
#define F_PUSH_RINDEXED_LVALUE         (128)
#define F_PUSH_AINDEXED_LVALUE         (129)
#define F_PUSH_INDEXED_S_LVALUE        (130)
#define F_INDEX_LVALUE                 (131)
#define F_RINDEX_LVALUE                (132)
#define F_AINDEX_LVALUE                (133)
#define F_INDEX_S_LVALUE               (134)
#define F_RANGE_LVALUE                 (135)
#define F_NR_RANGE_LVALUE              (136)
#define F_RN_RANGE_LVALUE              (137)
#define F_RR_RANGE_LVALUE              (138)
#define F_NA_RANGE_LVALUE              (139)
#define F_RA_RANGE_LVALUE              (140)
#define F_AN_RANGE_LVALUE              (141)
#define F_AR_RANGE_LVALUE              (142)
#define F_AA_RANGE_LVALUE              (143)
#define F_NX_RANGE_LVALUE              (144)
#define F_RX_RANGE_LVALUE              (145)
#define F_AX_RANGE_LVALUE              (146)
#define F_PUSH_PROTECTED_INDEXED_LVALUE (147)
#define F_PUSH_PROTECTED_RINDEXED_LVALUE (148)
#define F_PUSH_PROTECTED_AINDEXED_LVALUE (149)
#define F_PUSH_PROTECTED_INDEXED_MAP_LVALUE (150)
#define F_PUSH_PROTECTED_INDEXED_S_LVALUE (151)
#define F_PROTECTED_INDEX_LVALUE       (152)
#define F_PROTECTED_RINDEX_LVALUE      (153)
#define F_PROTECTED_AINDEX_LVALUE      (154)
#define F_PROTECTED_INDEX_S_LVALUE     (155)
#define F_PROTECTED_RANGE_LVALUE       (156)
#define F_PROTECTED_NR_RANGE_LVALUE    (157)
#define F_PROTECTED_RN_RANGE_LVALUE    (158)
#define F_PROTECTED_RR_RANGE_LVALUE    (159)
#define F_PROTECTED_NA_RANGE_LVALUE    (160)
#define F_PROTECTED_RA_RANGE_LVALUE    (161)
#define F_PROTECTED_AN_RANGE_LVALUE    (162)
#define F_PROTECTED_AR_RANGE_LVALUE    (163)
#define F_PROTECTED_AA_RANGE_LVALUE    (164)
#define F_PROTECTED_NX_RANGE_LVALUE    (165)
#define F_PROTECTED_RX_RANGE_LVALUE    (166)
#define F_PROTECTED_AX_RANGE_LVALUE    (167)
#define F_SIMUL_EFUN                   (168)
#define F_AGGREGATE                    (169)
#define F_M_AGGREGATE                  (170)
#define F_M_CAGGREGATE                 (171)
#define F_S_AGGREGATE                  (172)
#define F_S_M_AGGREGATE                (173)
#define F_PREVIOUS_OBJECT0             (174)
#define F_LAMBDA_CCONSTANT             (175)
#define F_LAMBDA_CONSTANT              (176)
#define F_PUSH_INDEXED_MAP_LVALUE      (177)
#define F_FOREACH                      (178)
#define F_FOREACH_REF                  (179)
#define F_FOREACH_RANGE                (180)
#define F_FOREACH_NEXT                 (181)
#define F_FOREACH_END                  (182)
#define F_END_CATCH                    (183)
#define F_BREAK_CONTINUE               (184)
#define F_BREAKN_CONTINUE              (185)
#define F_JUMP                         (186)
#define F_NO_WARN_DEPRECATED           (187)
#define F_ARRAY_RANGE_CHECK            (188)

/* --- efuns --- */

#define F_CALL_DIRECT                  (189)
#define F_CALL_OTHER                   (190)
#define F_CLONEP                       (191)
#define F_CLOSUREP                     (192)
#define F_EXTERN_CALL                  (193)
#define F_FLOATP                       (194)
#define F_INTP                         (195)
#define F_MAPPINGP                     (196)
#define F_MASTER                       (197)
#define F_NEGATE                       (198)
#define F_OBJECTP                      (199)
#define F_POINTERP                     (200)
#define F_RAISE_ERROR                  (201)
#define F_REFERENCEP                   (202)
#define F_SIZEOF                       (203)
#define F_STRINGP                      (204)
#define F_STRLEN                       (205)
#define F_STRUCTP                      (206)
#define F_SYMBOLP                      (207)
#define F_THIS_INTERACTIVE             (208)
#define F_THIS_OBJECT                  (209)
#define F_THIS_PLAYER                  (210)
#define F_THROW                        (211)
#define F_TYPEOF                       (212)

/* --- efun0s --- */

#define F_CALL_OUT_INFO                (213)
#define F_CALLER_STACK_DEPTH           (214)
#define F_COMMAND_STACK                (215)
#define F_COMMAND_STACK_DEPTH          (216)
#define F_DB_HANDLES                   (217)
#define F_DISABLE_COMMANDS             (218)
#define F_ENABLE_COMMANDS              (219)
#define F_END_MCCP_COMPRESS            (220)
#define F_GET_EVAL_COST                (221)
#define F_HEART_BEAT_INFO              (222)
#define F_QUERY_COMMAND                (223)
#define F_QUERY_LOAD_AVERAGE           (224)
#define F_QUERY_UDP_PORT               (225)
#define F_REGEXP_PACKAGE               (226)
#define F_RUSAGE                       (227)
#define F_TIME                         (228)
#define F_TLS_AVAILABLE                (229)
#define F_TLS_REFRESH_CERTS            (230)
#define F_UNSHADOW                     (231)
#define F_USERS                        (232)
#define F_UTIME                        (233)
#define F_WIZLIST_INFO                 (234)

/* --- efun1s --- */

#define F_ABS                          (235)
#define F_ACOS                         (236)
#define F_ALL_INVENTORY                (237)
#define F_ASIN                         (238)
#define F_ATAN                         (239)
#define F_BLUEPRINT                    (240)
#define F_CALLER_STACK                 (241)
#define F_CAPITALIZE                   (242)
#define F_CEIL                         (243)
#define F_CLONE_OBJECT                 (244)
#define F_COPY                         (245)
#define F_COS                          (246)
#define F_COUNT_BITS                   (247)
#define F_CTIME                        (248)
#define F_DB_AFFECTED_ROWS             (249)
#define F_DB_CLOSE                     (250)
#define F_DB_COLDEFS                   (251)
#define F_DB_CONV_STRING               (252)
#define F_DB_ERROR                     (253)
#define F_DB_FETCH                     (254)
#define F_DB_INSERT_ID                 (255)
#define F_DEEP_COPY                    (256)
#define F_DESTRUCT                     (257)
#define F_EXP                          (258)
#define F_EXPORT_UID                   (259)
#define F_FILE_SIZE                    (260)
#define F_FIND_CALL_OUT                (261)
#define F_FIND_OBJECT                  (262)
#define F_FIRST_INVENTORY              (263)
#define F_FLOOR                        (264)
#define F_GET_COMBINE_CHARSET          (265)
#define F_GET_CONNECTION_CHARSET       (266)
#define F_GET_EXTRA_WIZINFO            (267)
#define F_GET_MAX_COMMANDS             (268)
#define F_GETEUID                      (269)
#define F_GETUID                       (270)
#define F_GMTIME                       (271)
#define F_INPUT_TO_INFO                (272)
#define F_INTERACTIVE                  (273)
#define F_INVERT_BITS                  (274)
#define F_LAST_BIT                     (275)
#define F_LIVING                       (276)
#define F_LOAD_NAME                    (277)
#define F_LOAD_OBJECT                  (278)
#define F_LOCALTIME                    (279)
#define F_LOG                          (280)
#define F_LOWER_CASE                   (281)
#define F_M_INDICES                    (282)
#define F_MAKE_SHARED_STRING           (283)
#define F_MKDIR                        (284)
#define F_MKTIME                       (285)
#define F_NEXT_INVENTORY               (286)
#define F_NOTIFY_FAIL                  (287)
#define F_OBJECT_NAME                  (288)
#define F_OBJECT_TIME                  (289)
#define F_PREVIOUS_OBJECT              (290)
#define F_PROCESS_STRING               (291)
#define F_PROGRAM_NAME                 (292)
#define F_PROGRAM_TIME                 (293)
#define F_QUERY_EDITING                (294)
#define F_QUERY_IDLE                   (295)
#define F_QUERY_INPUT_PENDING          (296)
#define F_QUERY_IP_NAME                (297)
#define F_QUERY_IP_NUMBER              (298)
#define F_QUERY_LIMITS                 (299)
#define F_QUERY_MCCP                   (300)
#define F_QUERY_MCCP_STATS             (301)
#define F_QUERY_MUD_PORT               (302)
#define F_QUERY_NOTIFY_FAIL            (303)
#define F_QUERY_ONCE_INTERACTIVE       (304)
#define F_QUERY_SHADOWING              (305)
#define F_QUERY_SNOOP                  (306)
#define F_QUERY_VERB                   (307)
#define F_QUOTE                        (308)
#define F_RANDOM                       (309)
#define F_REMOVE_CALL_OUT              (310)
#define F_REMOVE_INTERACTIVE           (311)
#define F_RESTORE_OBJECT               (312)
#define F_RESTORE_VALUE                (313)
#define F_REVERSE                      (314)
#define F_RM                           (315)
#define F_RMDIR                        (316)
#define F_SET_BUFFER_SIZE              (317)
#define F_SET_COMBINE_CHARSET          (318)
#define F_SET_EXTRA_WIZINFO_SIZE       (319)
#define F_SET_HEART_BEAT               (320)
#define F_SET_LIGHT                    (321)
#define F_SET_MODIFY_COMMAND           (322)
#define F_SET_NEXT_RESET               (323)
#define F_SET_THIS_OBJECT              (324)
#define F_SET_THIS_PLAYER              (325)
#define F_SETEUID                      (326)
#define F_SGN                          (327)
#define F_SHUTDOWN                     (328)
#define F_SIN                          (329)
#define F_SQRT                         (330)
#define F_START_MCCP_COMPRESS          (331)
#define F_SYMBOL_VARIABLE              (332)
#define F_TAIL                         (333)
#define F_TAN                          (334)
#define F_TLS_DEINIT_CONNECTION        (335)
#define F_TLS_ERROR                    (336)
#define F_TLS_QUERY_CONNECTION_INFO    (337)
#define F_TLS_QUERY_CONNECTION_STATE   (338)
#define F_TO_ARRAY                     (339)
#define F_TO_FLOAT                     (340)
#define F_TO_INT                       (341)
#define F_TO_OBJECT                    (342)
#define F_TO_STRING                    (343)
#define F_TRACE                        (344)
#define F_TRACEPREFIX                  (345)
#define F_TRANSPOSE_ARRAY              (346)
#define F_UNMKMAPPING                  (347)
#define F_UNQUOTE                      (348)
#define F_UPPER_CASE                   (349)
#define F_WIDTHOF                      (350)
#define F_WRITE                        (351)
#define F_XML_GENERATE                 (352)
#define F_XML_PARSE                    (353)

/* --- efun2s --- */

#define F_AND_BITS                     (354)
#define F_ATAN2                        (355)
#define F_ATTACH_ERQ_DEMON             (356)
#define F_BASEOF                       (357)
#define F_BINARY_MESSAGE               (358)
#define F_CLEAR_BIT                    (359)
#define F_CONFIGURE_DRIVER             (360)
#define F_COPY_FILE                    (361)
#define F_CRYPT                        (362)
#define F_DB_EXEC                      (363)
#define F_DEBUG_MESSAGE                (364)
#define F_ENABLE_TELNET                (365)
#define F_EXEC                         (366)
#define F_EXPAND_DEFINE                (367)
#define F_EXPLODE                      (368)
#define F_FUNCTIONLIST                 (369)
#define F_GET_DIR                      (370)
#define F_GET_ERROR_FILE               (371)
#define F_IMPLODE                      (372)
#define F_LAMBDA                       (373)
#define F_LAST_INSTRUCTIONS            (374)
#define F_M_ALLOCATE                   (375)
#define F_M_DELETE                     (376)
#define F_M_ENTRY                      (377)
#define F_M_REALLOCATE                 (378)
#define F_M_VALUES                     (379)
#define F_MATCH_COMMAND                (380)
#define F_MD5_CRYPT                    (381)
#define F_MOVE_OBJECT                  (382)
#define F_NET_CONNECT                  (383)
#define F_OR_BITS                      (384)
#define F_POW                          (385)
#define F_QUERY_ACTIONS                (386)
#define F_REMOVE_ACTION                (387)
#define F_RENAME                       (388)
#define F_RENAME_OBJECT                (389)
#define F_SET_BIT                      (390)
#define F_SET_CONNECTION_CHARSET       (391)
#define F_SET_DRIVER_HOOK              (392)
#define F_SET_ENVIRONMENT              (393)
#define F_SET_EXTRA_WIZINFO            (394)
#define F_SET_IS_WIZARD                (395)
#define F_SET_MAX_COMMANDS             (396)
#define F_SET_PROMPT                   (397)
#define F_SHADOW                       (398)
#define F_STRUCT_INFO                  (399)
#define F_SYMBOL_FUNCTION              (400)
#define F_TELL_OBJECT                  (401)
#define F_TEST_BIT                     (402)
#define F_TLS_CHECK_CERTIFICATE        (403)
#define F_TRANSFER                     (404)
#define F_UNBOUND_LAMBDA               (405)
#define F_VARIABLE_LIST                (406)
#define F_XOR_BITS                     (407)

/* --- efun3s --- */

#define F_CONFIGURE_INTERACTIVE        (408)
#define F_CONVERT_CHARSET              (409)
#define F_EXECUTE_COMMAND              (410)
#define F_HMAC                         (411)
#define F_NEXT_BIT                     (412)
#define F_REGEXP                       (413)
#define F_REGEXPLODE                   (414)
#define F_SEND_ERQ                     (415)
#define F_SEND_UDP                     (416)
#define F_STRRSTR                      (417)
#define F_STRSTR                       (418)
#define F_WRITE_BYTES                  (419)
#define F_WRITE_FILE                   (420)

/* --- efun4s --- */

#define F_REGREPLACE                   (421)

/* --- vefuns --- */

#define F_ADD_ACTION                   (422)
#define F_ALL_ENVIRONMENT              (423)
#define F_ALLOCATE                     (424)
#define F_APPLY                        (425)
#define F_BIND_LAMBDA                  (426)
#define F_CALL_DIRECT_RESOLVED         (427)
#define F_CALL_OUT                     (428)
#define F_CALL_RESOLVED                (429)
#define F_CAT                          (430)
#define F_CLONES                       (431)
#define F_COMMAND                      (432)
#define F_COPY_BITS                    (433)
#define F_DB_CONNECT                   (434)
#define F_DEBUG_INFO                   (435)
#define F_DEEP_INVENTORY               (436)
#define F_ED                           (437)
#define F_ENVIRONMENT                  (438)
#define F_FILTER                       (439)
#define F_FILTER_INDICES               (440)
#define F_FILTER_OBJECTS               (441)
#define F_FIND_INPUT_TO                (442)
#define F_FUNCALL                      (443)
#define F_FUNCTION_EXISTS              (444)
#define F_GARBAGE_COLLECTION           (445)
#define F_GET_TYPE_INFO                (446)
#define F_HASH                         (447)
#define F_INCLUDE_LIST                 (448)
#define F_INHERIT_LIST                 (449)
#define F_INPUT_TO                     (450)
#define F_LIMITED                      (451)
#define F_M_ADD                        (452)
#define F_M_CONTAINS                   (453)
#define F_MAP                          (454)
#define F_MAP_INDICES                  (455)
#define F_MAP_OBJECTS                  (456)
#define F_MAX                          (457)
#define F_MD5                          (458)
#define F_MEMBER                       (459)
#define F_MIN                          (460)
#define F_MKMAPPING                    (461)
#define F_OBJECT_INFO                  (462)
#define F_PRESENT                      (463)
#define F_PRESENT_CLONE                (464)
#define F_PRINTF                       (465)
#define F_READ_BYTES                   (466)
#define F_READ_FILE                    (467)
#define F_REGMATCH                     (468)
#define F_REMOVE_INPUT_TO              (469)
#define F_REPLACE_PROGRAM              (470)
#define F_RMEMBER                      (471)
#define F_SAVE_OBJECT                  (472)
#define F_SAVE_VALUE                   (473)
#define F_SAY                          (474)
#define F_SET_LIMITS                   (475)
#define F_SHA1                         (476)
#define F_SNOOP                        (477)
#define F_SORT_ARRAY                   (478)
#define F_SPRINTF                      (479)
#define F_STRFTIME                     (480)
#define F_TELL_ROOM                    (481)
#define F_TERMINAL_COLOUR              (482)
#define F_TLS_INIT_CONNECTION          (483)
#define F_TO_STRUCT                    (484)
#define F_TRIM                         (485)
#define F_UNIQUE_ARRAY                 (486)
#define F_VARIABLE_EXISTS              (487)
#define F_WALK_MAPPING                 (488)

/************************************************************************/

#endif /* INSTRS_H__ */
